/* $Log:	preamble.c,v $
 * Revision 0.8  92/11/23  19:46:54  19:46:54  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:39  02:41:39  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:48:37  21:48:37  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:43  16:25:43  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:45:59  02:45:59  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:45:49  12:45:49  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:29:00  17:29:00  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:48  23:58:48  bt (Bo Thide')
 * First Release.
 *  */

/*
 * This routine processes the preamble and determines the global variables
 * 'conv' and 'magnification'. It exits if a fatal error is found in the
 * preamble.
 */

#include <stdio.h>
#include "dvi.h"
#include "globals.h"
#include "macros.h"

static char rcsid[] = "$Header: preamble.c,v 0.8 92/11/23 19:46:54 bt Exp $";

preamble(dvifile, resolution)
FILE	*dvifile;
short	resolution;
{ 
	ubyte	p;

	if(getubyte(dvifile) != DVI_PRE)
		sterror("Bad %s file: First byte is not start of preamble\n",
		  DVIFILE_SUFFIX);
	if(getubyte(dvifile) != 2)
		fprintf(stderr,"Identifier in byte 1 should be '2'");
	numerator   = (long)getsquad(dvifile);
	denominator = (long)getsquad(dvifile);

#ifdef DEBUG
	fprintf (stderr,"preamble: numerator=%d, denominator=%d\n",numerator,denominator);
#endif /* DEBUG */

	if(numerator <= 0)
		valerror("Bad .dvi file: Numerator is %d\n" , numerator);
	if(denominator <= 0 )
		valerror("Bad .dvi file: Denominator is %d\n" , denominator);
	magnification = (long)getsquad(dvifile);
	conv = ((double)numerator/254000.0)*(double)resolution*(double)magnification/((double)denominator*1000.0) ;

#ifdef DEBUG
	fprintf (stderr,"preamble: magnification=%d, conv=%g\n",magnification,conv);
#endif /* DEBUG */

	p = getubyte(dvifile);

#ifdef DEBUG2
	fprintf (stderr,"preamble: p = %d\n",p);
#endif /* DEBUG2 */
}
